import React from 'react';
import { NsAccordionItemProps, NsCollapse } from '..';
import NsAccordionHeader from './NsAccordionHeader';
import { StyledToggleSection } from './ToggleSection.styled';

/**
 * this component is used by accordion to pass title
 * and content
 */
const NsAccordionItem = ({
    isOpen,
    isChild,
    toggleOpen,
    title,
    content,
    variant,
    headerTypographyVariant,
    closedIconName,
    openedIconName,
    startIcon,
    level,
    additionalProps,
    invert,
}: NsAccordionItemProps) => {
    return (
        <StyledToggleSection variant={variant}>
            <NsAccordionHeader
                invert={invert}
                additionalProps={{ ...additionalProps, className: 'accordion-section ' + additionalProps?.className }}
                closedIconName={closedIconName}
                headerTypographyVariant={headerTypographyVariant}
                isOpen={isOpen}
                openedIconName={openedIconName}
                onClick={toggleOpen}
                title={title}
                variant={variant}
                startIcon={startIcon}
            />
            <NsCollapse
                isChild={isChild}
                isOpen={isOpen}
                variant={variant}
                level={level}
                invert={invert}
                content={content}
            />
        </StyledToggleSection>
    );
};

export default NsAccordionItem;
