import { NsIconProps } from '../..';
import { AccordionItem, ItemContent } from '../types';

const getItem = () => {
    return {
        id: parseInt(Math.random() * 10000000 + '') + '',
    };
};
const getIcon = (name = '', color = '') => {
    return {
        name: (name || 'home') as NsIconProps['name'],
        color: (color || 'primary') as NsIconProps['color'],
    };
};
export const getTextContent = (text = '') => {
    return {
        type: 'text' as ItemContent['type'],
        data: text || dummyText,
    };
};
const getJsxContent = (text = '') => {
    return <div className="p-4">{text || 'Content type can be jsx, text, html or Accordion'}</div>;
};
export const dummyText = `1. Theme can be set to either ‘gray’ or ‘stripe’, adjusting only the appearance of
the topmost set of accordions.\n
2. Accordions can be nested repeatedly, internal accordions follow the ‘gray’ theme.\n
3. Color can be inverted by setting boolean ‘invert’ attribute. This inversion affects all levels of the accordion.\n
4. Per level offset of accordion can be changed by setting the level attribute.\n
Defaults to 1 which is zero offset - all level titles appear stacked directly over each other.`;
function createAccordionItem1(): AccordionItem {
    return {
        ...getItem(),
        icon: getIcon(),
        title: 'Example - 1 JSX',
        content: getJsxContent(),
        isDefaultOpen: true,
    };
}
function createAccordionItem2(): AccordionItem {
    return {
        ...getItem(),
        isDefaultOpen: true,
        icon: getIcon(),
        title: 'Example - 2',
        content: {
            type: 'accordion',
            data: [
                { ...getItem(), title: 'Example - 2.1', content: getTextContent() },
                {
                    ...getItem(),
                    icon: getIcon('hamburgerIcon', 'success'),
                    title: 'Example - 2.2',
                    content: <div className="p-2">Example 2.2 Content</div>,
                },
            ],
        },
    };
}
function createAccordionItem3(): AccordionItem {
    return {
        ...getItem(),
        icon: getIcon('hamburgerIcon', 'success'),
        title: 'Example - 3',
        content: {
            type: 'accordion',
            data: [
                createAccordionItem3_1(),
                {
                    ...getItem(),

                    title: 'Example - 3.2',
                    content: {
                        type: 'text',
                        data: dummyText,
                    },
                },
            ],
        },
    };
}

export function createAccordionItem3_1(): AccordionItem {
    return {
        ...getItem(),
        title: 'Example - 3.1',
        content: {
            type: 'accordion',
            allowMultipleExpanded: true,
            data: [
                {
                    ...getItem(),
                    title: 'Example - 3.1.1',
                    content: {
                        type: 'text',
                        data: dummyText,
                    },
                },
                {
                    ...getItem(),
                    title: 'Example - 3.1.2',
                    content: {
                        type: 'text',
                        data: dummyText,
                    },
                },
            ],
        },
    };
}

function createAccordionItem4(): AccordionItem {
    return {
        ...getItem(),
        icon: getIcon(),
        title: 'Example - 4',
        content: {
            type: 'accordion',
            data: [
                createAccordionItem4_1(),
                {
                    ...getItem(),
                    title: 'Example - 4.2',
                    content: {
                        type: 'html',
                        data: '<h2>Lorem ipsum dolor sit amet.</h2>',
                    },
                },
            ],
        },
    };
}

function createAccordionItem4_1(): AccordionItem {
    return {
        ...getItem(),
        title: 'Example - 4.1',
        content: {
            type: 'accordion',
            data: [
                {
                    ...getItem(),

                    title: 'Example - 4.1.1',
                    content: {
                        type: 'text',
                        data: dummyText,
                    },
                },
                {
                    ...getItem(),
                    content: <div className="p-3">Example 4.1.2. content</div>,
                    title: 'Example - 4.1.2',
                },
            ],
        },
    };
}
export function getAccordionData(): AccordionItem[] {
    return [createAccordionItem1(), createAccordionItem2(), createAccordionItem3(), createAccordionItem4()];
}
